#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct ConflictOnSeriesCreation {
    #[serde(rename = "datasetRid")]
    dataset_rid: conjure_object::ResourceIdentifier,
    #[builder(default, into)]
    #[serde(rename = "csvIndex", skip_serializing_if = "Option::is_none", default)]
    csv_index: Option<i32>,
}
impl ConflictOnSeriesCreation {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(dataset_rid: conjure_object::ResourceIdentifier) -> Self {
        Self::builder().dataset_rid(dataset_rid).build()
    }
    #[inline]
    pub fn dataset_rid(&self) -> &conjure_object::ResourceIdentifier {
        &self.dataset_rid
    }
    #[inline]
    pub fn csv_index(&self) -> Option<i32> {
        self.csv_index.as_ref().map(|o| *o)
    }
}
impl conjure_error::ErrorType for ConflictOnSeriesCreation {
    #[inline]
    fn code() -> conjure_error::ErrorCode {
        conjure_error::ErrorCode::Conflict
    }
    #[inline]
    fn name() -> &'static str {
        "Catalog:ConflictOnSeriesCreation"
    }
    #[inline]
    fn safe_args() -> &'static [&'static str] {
        &["csvIndex", "datasetRid"]
    }
}
